/*****
 * CNeoApp.h
 *
 *	Application class for a typical application.
 *  Copyright  1992-1994 NeoLogic Systems.  All rights reserved.
 *
 *****/
#pragma once			/* Include this file only once */
#ifndef __CNeoApp__
#define __CNeoApp__

#include <Processes.h>
#include CNeoAppBaseH

class CNeoApp : public CNeoAppBase
{
public:
						/** Constructors / Destructors **/
						CNeoApp(const OSType aSignature, const OSType aType);
	void				INeoApp(void);
	virtual				~CNeoApp(void);

						/** Execution Methods **/
	virtual void		getAppName(Str255 aName) const;
	virtual short		getAppVersion(char *aData) const;
	virtual Boolean		isFrontProcess(void) const;

						/** Chore Methods **/
	virtual void		addChore(CNeoChore *aChore);
	virtual void		doChores(void);
	virtual void		removeChore(CNeoChore *aChore);

						/** Purge Methods **/
	virtual Boolean		purgeCache(long aNeeded);

	static long			FNumWindowsOpen;		// The number of windows open
	static ProcessSerialNumber
						FPSN;					// This application's psn
};
#endif
