 /************************************************************
 *
 *	Created: Friday, March 8, 1991 11:24:46 AM
 *	CNeoDatabasePP.h
 *	C++ class implementation for PowerPlant -based file class
 *
 *
 *	Copyright  Neologic Systems 1992-1993. All Rights Reserved.
 *	All rights reserved
 *
 *
 * The CNeoDatabasePP class is, in effect, an area manager. The area it manages is a
 * string of bytes that can be added to at the end. Access to the area however
 * is slower than accessing main memory. Information in the area can only be
 * accessed by allocating space in main memory. This main memory space needs
 * to be used as a cache of the database's contents.
 *
 ***********************************************************/
#pragma once			/* Include this file only once */

#include "NeoTypes.h"
#include CNeoDatabaseH
#include <StandardFile.h>

class CNeoDatabasePP : public CNeoDatabase
{
public:
						/** Instance Methods **/
						CNeoDatabasePP(OSType aCreator, OSType aType);
	virtual				~CNeoDatabasePP(void);

						/** Purging Methods **/
	static Boolean		PurgeCache(long aNeeded);

						/** Macintosh-Specfic Methods **/
	virtual OSType		getCreator(void) const;
	virtual OSType		getType(void) const;
	virtual void		setCreator(const OSType aCreator);
	virtual void		setType(const OSType aType);

						/** PowerPlant-specific Methods **/
	virtual void		CloseDataFork(void);
	virtual void		CreateNewFile(OSType aCreator, OSType aType, ScriptCode aScriptCode = smSystemScript);
	virtual void		CreateNewDataFile(OSType aCreator, OSType aType, ScriptCode aScriptCode = smSystemScript);
	Int16				GetDataForkRefNum(void);
	virtual Int16		OpenDataFork(Int16 inPrivileges);
	void				SFSpecify(SFReply *macSFReply);
	void				Specify(const FSSpec *aFileSpec);

protected:
	OSType				fType;				// file system type of the database
	OSType				fCreator;			// file system creator of this database
};