/****
 * CNeoDocPP.h
 *
 *	Document class for a PowerPlant-based document.
 *  Copyright  1992-1993 NeoLogic Systems.  All rights reserved.
 *
 ****/
#pragma once			/* Include this file only once */

#include "NeoTypes.h"
#include CNeoDatabaseNativeH
#include CNeoDocH
#include "LListener.h"
#include "LCommander.h"

class LWindow;

class CNeoDocPP : public CNeoDoc, public LListener {
public:
						// Instance Methods
						CNeoDocPP(const OSType aCreator, const OSType aType, const Boolean aPrintable, const Boolean aNewDatabase, const Boolean aCreateDatabase = TRUE);
	virtual 	        ~CNeoDocPP(void);

	virtual void		buildWindow(void) = 0;
	virtual void		DoSave(void);
	virtual void		DoAESave(FSSpec	&aSpec, OSType aType);
	virtual StringPtr	GetDescriptor(Str255 outDescriptor) const;
	virtual CNeoDatabaseNative *
						getDatabase(void) const {return (CNeoDatabaseNative *)mFile;}
	virtual Boolean		isDirty(void) const {return mIsModified;}
	virtual void		ListenToMessage(MessageT aMessage, void *aParam);
	virtual void		newDatabase(void);
	virtual void		openFile(FSSpec *aSpec);
	virtual void		setDirty(const Boolean aState = TRUE) {mIsModified = aState;}
	virtual void		setDatabase(CNeoDatabaseNative *aDatabase);
	void				setWindow(LWindow *aWindow) {mWindow = aWindow;}

	static CNeoDocPP *	FindByFSSpec(FSSpec *aSpec);
	static CNeoDocPP *	FindByWindow(const CNeoWindowBase *aWindow);
	static CNeoDocPP *	FindTop(void);

protected:
	Boolean				fNewDatabase;				// Is this doc's database a newly created one
	Boolean				fRemote;					// Is document accessing remote database
	Int16				fOpenMode;
};
